
#line 3 "lex.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 228
#define YY_END_OF_BUFFER 229
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[659] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      229,  227,  226,  226,  227,  101,  102,  113,  111,  109,
      112,  110,  114,  224,  224,  115,  100,  103,  116,  104,
      222,  151,  222,  143,  222,  153,  129,  222,  222,  222,
      222,  222,  121,  222,  222,  222,  129,  222,  222,  222,
      157,  147,  222,  107,  108,  105,  106,    8,    9,    8,
        8,   17,  228,   16,   13,   14,   15,   11,  228,  226,
        0,    0,    0,    0,    0,    0,    0,  212,  215,    0,
      217,    0,  220,  219,    0,  221,  211,    6,    0,    0,
      224,    0,  152,  144,  154,    0,  158,  148,  119,  222,

      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,   76,  222,  222,
      222,  222,  222,  222,  127,  127,  127,  222,  222,  128,
      222,  222,   64,  222,  222,  132,  222,  222,  222,  222,
      222,  222,  120,  222,  222,  222,  222,  222,  222,  126,
      126,  222,  222,   53,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  149,  141,  222,  222,  145,  155,  222,
      222,  222,  222,  222,    7,   11,   11,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  216,    0,

      218,  214,  213,    0,    0,    0,    1,    1,  225,  223,
      150,  142,  146,  156,  222,   49,  222,  222,  222,   52,
       57,  222,   48,  222,   33,  222,  222,   81,   80,  222,
      222,  222,  222,   58,  222,  222,  194,  130,   93,  222,
       46,   45,   43,   44,  222,  222,  222,  222,  186,  189,
      222,  222,   29,   30,   20,  222,  222,   65,  222,  139,
      222,  187,  222,  222,  222,  140,  188,   32,   26,   38,
       31,  222,  222,  222,   19,  222,  123,  222,  222,   37,
        0,  222,  222,   62,   25,  222,   82,   74,  192,  222,
      222,   79,  222,  222,  191,  222,  222,  222,  222,   51,

      222,   56,   55,  222,  193,  222,  131,  222,  222,  222,
      222,  222,  222,   90,  222,   92,  222,  222,  222,   54,
       12,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  173,  223,  118,  222,   50,  222,
      222,  222,  222,  168,   34,   35,  222,  222,   78,   47,
      222,   59,  222,   69,  222,  222,  222,   67,  222,  222,
      222,  222,   70,  222,  137,  222,  222,  222,   63,   40,
      222,  138,   39,  222,   85,   83,  222,  222,  124,  125,
      222,  222,   18,   72,   88,   84,   22,   23,   21,   24,
       41,  222,  222,  222,  222,   61,  222,  222,  190,  222,

       60,  222,  222,  222,  172,   96,   75,  222,  222,    0,
        0,    0,   10,  117,    0,    0,    0,    0,  202,    0,
        0,    0,    0,  201,    0,    0,    0,    0,    0,    0,
      222,  222,  222,  133,  222,   36,   68,  136,  222,  177,
      222,  222,  222,   77,  222,  222,  222,  134,  222,  222,
      222,  135,  122,  222,   73,   71,  222,  222,   42,  222,
      222,  222,  222,  222,  222,  222,  222,  222,   66,   89,
      161,    0,    0,   10,    0,  204,  206,  208,    0,  203,
      205,  207,    0,    4,    4,    0,    0,    0,    0,    0,
        0,  222,  174,  222,  179,  222,  222,  222,  222,  222,

      222,  222,  222,  196,  222,  197,  222,  222,  222,  183,
      222,  200,  222,  199,  195,  222,  178,  222,  222,    0,
        0,    0,  210,  209,    0,    0,    0,    0,    0,    0,
      222,  175,  222,  222,  222,  222,  222,  222,   27,   28,
       87,  222,  222,  222,  180,  181,   86,  176,  222,  222,
      222,    0,    0,  159,  167,    0,    0,    0,    0,    2,
        2,    0,  222,   95,  222,   97,  222,  222,  222,  222,
      222,  222,  222,  222,  222,    0,    0,    0,    0,    0,
        0,  185,  222,   94,  171,  222,  198,  222,  222,  170,
      222,   98,  162,    0,    0,    0,    0,    5,    5,    0,

        0,  184,  222,   99,  222,  222,    0,    0,    0,    0,
        0,  169,  222,  222,  160,    0,    0,    0,    3,    3,
        0,    0,  182,  222,    0,    0,    0,    0,  222,    0,
        0,    0,    0,   91,    0,    0,    0,    0,    0,    0,
        0,  164,    0,    0,    0,    0,    0,  163,    0,    0,
        0,    0,    0,    0,    0,  166,  165,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    1,    6,    7,    1,    1,    1,    1,    8,
        9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
       19,   20,   21,   22,   21,   23,   21,   24,   25,   26,
       27,   28,    1,    1,   29,   30,   31,   32,   33,   34,
       35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
       45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
       55,    1,   56,    1,   57,    1,   58,   59,   60,   61,

       62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
       72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
       82,   83,   84,    1,   85,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[86] =
    {   0,
        1,    1,    1,    1,    1,    2,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    3,    3,    3,    3,    3,
        3,    3,    3,    1,    1,    1,    1,    1,    3,    3,
        3,    3,    3,    3,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    1,    1,    4,    3,    3,    3,
        3,    3,    3,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    1
    } ;

static yyconst flex_int16_t yy_base[671] =
    {   0,
        0,    0,   83,   85,   87,   91,   80,   88,  702,  684,
      688, 1578,  110,  114,   78,   62, 1578, 1578, 1578, 1578,
      105,  146,  119,  132,  142,  193, 1578, 1578, 1578, 1578,
      258,  153,  190,  239,  251,  322,  337,  108,  196,  135,
        0,  324,  392,  406,  134,  192,  469,  517,  249,  401,
      328,  407,  140, 1578, 1578, 1578, 1578, 1578, 1578, 1578,
      672, 1578, 1578, 1578, 1578, 1578, 1578,  366,    0,  128,
      462,  160,  204,  582,  306,  212,  225,  246,  259,  263,
      268,  318, 1578,  271,  278, 1578, 1578, 1578,  132,  590,
      600,    0, 1578, 1578, 1578,  464,  313, 1578,  608,    0,

      319,  331,  397,  335,  341,  328,  373,  382,  383,  466,
      473,  400,  405,  469,  510,  616,  396,    0,  500,  403,
      467,  422,  431,  453,    0,  662,  597,  519,  479,  624,
      499,  509,  522,  619,  510,    0,  517,  522,  621,  616,
      608,  621,  638,  638,  629,  613,  631,  684,  625,  703,
      711,  703,  627,    0,  641,  692,  642,  708,  676,  678,
      666,  709,  717,  717,  709,  718,  706,  774,  724,  721,
      723,  742,  730,    0,    0,  769,  768,    0,    0,  769,
      767,  769,  770,  762, 1578,  589,  804,  561,  767,  769,
      779,  771,  767,  775,  763,  785,  798,  786, 1578,  773,

     1578, 1578, 1578,  803,  801,  187, 1578,  198,  834,    0,
     1578, 1578, 1578, 1578,  852,  828,  825,  819,  816,    0,
        0,  823,    0,  832,    0,  228,  833,    0,    0,  847,
      837,  831,  833,  839,  838,  835,    0,  897,    0,  867,
        0,    0,    0,    0,  851,  857,  866,  863,    0,    0,
      853,  854,    0,    0,    0,  871,  859,    0,  874,  890,
      902,    0,  886,  891,  890,  906,    0,    0,    0,  903,
        0,  901,  905,  900,    0,  897,  938,  895,  959,    0,
      967,  930,  936,    0,    0,  952,    0,    0,    0,  957,
      963,    0,  954,  965,    0,  981,  956,  961,  966,    0,

      971,    0,    0,  962,  974,  958, 1033,  961,  978,  961,
      978,  970,  980,    0,  983,    0,  968,  977,  970,    0,
     1578,  996, 1026, 1013, 1027,  528, 1044, 1048, 1030, 1030,
     1043,  464, 1031,  460, 1578,    0, 1058, 1036,    0, 1041,
     1053, 1046, 1049,    0,    0,    0, 1040, 1052,    0,    0,
     1054,    0, 1057,    0,  450, 1062, 1063,    0, 1066, 1061,
     1062, 1055,    0, 1068,    0, 1071, 1063, 1067,    0,    0,
     1077,    0,    0, 1130,    0,    0, 1080, 1097, 1144, 1152,
     1123, 1108,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  440, 1116, 1147, 1148,    0, 1145, 1136,    0, 1147,

        0, 1150, 1153, 1139,    0,    0,    0, 1155, 1156, 1157,
      363, 1149,  401, 1578,  378, 1156, 1157, 1158, 1578,  327,
     1159, 1160, 1161, 1578,  247, 1169, 1150, 1173, 1167, 1170,
     1171,  309, 1174,    0, 1182,    0, 1170,    0, 1183,    0,
     1190, 1200, 1194,    0,  297,  296, 1208,    0, 1188, 1199,
     1208,    0, 1230, 1212,    0,    0, 1218, 1216,    0, 1223,
     1211, 1219, 1228, 1214, 1227, 1234, 1239, 1228,    0,    0,
     1578, 1243, 1242,  252, 1240, 1578, 1578, 1578, 1241, 1578,
     1578, 1578,  306, 1578,  401, 1232, 1239, 1237, 1248, 1252,
     1250, 1246,  231, 1247,    0, 1253, 1249, 1255, 1265, 1264,

      229,  217, 1260, 1273, 1282,    0, 1279, 1278, 1272,    0,
     1273,    0, 1286,    0,    0, 1291,    0,  146, 1286, 1287,
     1299, 1293, 1578, 1578, 1301, 1287, 1304, 1291,  415, 1289,
     1293,    0, 1307, 1313, 1318, 1306, 1310, 1307,    0,    0,
        0, 1312, 1327, 1313,    0,    0,    0,    0, 1327, 1324,
     1325, 1341, 1328, 1578, 1578,  141, 1342, 1334,  453, 1578,
      471, 1335, 1338,    0, 1344,    0, 1339, 1346, 1353, 1359,
     1342, 1364, 1352, 1351, 1363, 1364, 1356, 1385,  566, 1375,
     1361,    0, 1362,    0,    0, 1357,    0, 1379, 1383,    0,
     1385,    0, 1578, 1395, 1377, 1397,  568, 1578,  570, 1392,

      139,    0, 1400,    0, 1394, 1384, 1396, 1411, 1410,  668,
     1402,    0, 1415, 1407, 1578, 1420, 1415,  670, 1578,  672,
     1424, 1411,    0, 1422, 1407, 1419, 1414, 1420, 1423, 1422,
     1423, 1432, 1447,    0, 1449, 1454, 1445, 1449, 1447, 1445,
     1463, 1578, 1451,  137, 1462,  100, 1454, 1578, 1456, 1451,
     1469, 1463, 1454, 1476, 1477, 1578, 1578, 1578, 1539, 1543,
     1547, 1549, 1553, 1557,  129,  111, 1561, 1565, 1569, 1573
    } ;

static yyconst flex_int16_t yy_def[671] =
    {   0,
      658,    1,  659,  659,  660,  660,  661,  661,  661,  661,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  663,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  664,  658,
      658,  665,  658,  658,  658,  658,  658,  658,  662,  662,

      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  658,  658,  658,  663,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,

      658,  658,  658,  658,  658,  664,  658,  664,  658,  666,
      658,  658,  658,  658,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      658,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,

      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  666,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  658,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,

      662,  662,  662,  662,  662,  662,  662,  662,  662,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  667,  658,  658,  658,  658,  658,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  667,  658,  667,  658,  658,  658,  658,  658,
      658,  662,  662,  662,  662,  662,  662,  662,  662,  662,

      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  668,  658,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  658,  658,  658,  658,  658,  658,  658,  668,  658,
      668,  658,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  658,  658,  658,  669,  658,
      658,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  658,  658,  658,  658,  669,  658,  669,  658,

      658,  662,  662,  662,  662,  662,  658,  658,  658,  670,
      658,  662,  662,  662,  658,  658,  658,  670,  658,  670,
      658,  658,  662,  662,  658,  658,  658,  658,  662,  658,
      658,  658,  658,  662,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,    0,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658
    } ;

static yyconst flex_int16_t yy_nxt[1664] =
    {   0,
       12,   13,   14,   12,   13,   12,   15,   16,   17,   18,
       19,   20,   21,   22,   23,   24,   25,   25,   25,   25,
       25,   25,   25,   26,   27,   28,   29,   30,   31,   32,
       33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
       43,   44,   45,   46,   41,   47,   48,   49,   50,   51,
       52,   53,   41,   41,   54,   55,   41,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   41,   47,   48,   49,   50,   51,   52,
       53,   41,   41,   56,   57,   59,   60,   59,   60,   63,
       73,   71,   61,   63,   61,   68,   68,   68,   68,   68,

       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   70,   70,  336,   70,   70,   70,   72,   70,   73,
       74,   74,   74,   74,   74,   74,   74,   74,   88,   70,
       70,  210,   70,   89,  207,  208,  132,   64,   65,   66,
       67,   64,   65,   66,   67,   90,   72,   91,   91,   91,
       91,   91,   91,   91,   91,   90,  649,   91,   91,   91,
       91,   91,   91,   91,   91,  132,   64,   65,   66,   67,
       64,   65,   66,   67,   75,  137,   76,   77,   78,  154,
       79,  109,  184,   92,   80,   81,  110,   82,   83,  207,
      208,   84,   85,  647,   86,  611,  192,  578,  111,   87,

      207,  208,  550,   75,  137,   76,   77,   78,  154,   79,
      109,  184,   92,   80,   81,  110,   82,   83,  112,  113,
       84,   85,   93,   86,   94,  192,   95,  111,   87,  133,
      114,  155,  115,  193,  156,  116,  134,  135,  540,  136,
      157,   96,   97,   98,  345,  346,  539,  112,  113,  484,
      485,   93,  532,   94,  196,   95,  474,  197,  133,  114,
      155,  115,  193,  156,  116,  134,  135,  117,  136,  157,
       96,   97,   98,   99,   99,   99,   99,   99,   99,   99,
       99,  118,  119,  196,  171,  120,  197,  198,  101,  102,
      121,  199,  122,  123,  172,  200,  117,  103,  104,  105,

      201,  173,  124,  204,  106,  107,  205,  108,  484,  485,
      118,  119,  502,  171,  120,  501,  198,  101,  102,  121,
      199,  122,  123,  172,  200,  493,  103,  104,  105,  201,
      173,  124,  204,  106,  107,  205,  108,  125,  126,  125,
      127,  125,  125,  125,  125,  194,  214,  195,  479,  215,
      202,  128,  130,  130,  130,  130,  130,  130,  130,  130,
      138,  179,  216,  219,  139,  131,  140,  129,  180,  141,
      186,  203,  220,  221,  194,  214,  195,  142,  215,  202,
      128,  187,  187,  187,  187,  187,  187,  187,  187,  138,
      179,  216,  219,  139,  131,  140,  129,  180,  141,  475,

      203,  220,  221,  484,  485,  474,  142,  143,  143,  143,
      143,  143,  143,  143,  143,  222,  223,  560,  561,  472,
      144,  150,  151,  151,  151,  151,  151,  151,  151,  224,
      174,  145,  175,  217,  146,  181,  218,  147,  148,  231,
      149,  232,  182,  240,  222,  223,  176,  177,  152,  144,
      245,  178,  183,  248,  153,  560,  561,  459,  224,  174,
      145,  175,  217,  146,  181,  218,  147,  148,  231,  149,
      232,  182,  240,  560,  561,  176,  177,  152,  249,  245,
      178,  183,  248,  153,  130,  130,  130,  130,  130,  130,
      130,  130,  189,  211,  190,  212,  250,  233,  225,  246,

      191,  158,  226,  228,  229,  230,  441,  249,  159,  255,
      160,  227,  234,  247,  213,  161,  430,  241,  242,  243,
      428,  189,  211,  190,  212,  250,  233,  225,  246,  191,
      158,  226,  228,  229,  230,  244,  414,  159,  255,  160,
      227,  234,  247,  213,  161,  162,  256,  163,  257,  164,
      235,  236,  165,  166,  253,  258,  237,  261,  254,  262,
      263,  167,  168,  264,  244,  169,  321,  170,  598,  599,
      598,  599,  598,  599,  162,  256,  163,  257,  164,  235,
      236,  165,  166,  253,  258,  237,  261,  254,  262,  263,
      167,  168,  264,  186,  169,   90,  170,   74,   74,   74,

       74,   74,   74,   74,   74,  209,  209,  209,  209,  209,
      209,  209,  209,   90,  252,   91,   91,   91,   91,   91,
       91,   91,   91,   99,   99,   99,   99,   99,   99,   99,
       99,  238,  238,  238,  238,  238,  238,  238,  238,  130,
      130,  130,  130,  130,  130,  130,  130,  259,  239,  265,
      267,  268,  269,  143,  143,  143,  143,  143,  143,  143,
      143,  274,  275,  276,  280,  260,  286,  266,  270,  271,
      619,  620,  619,  620,  619,  620,  259,  239,  265,  267,
      268,  269,  287,  251,  272,  273,  185,  658,  290,   69,
      274,  275,  276,  280,  260,  286,  266,  270,  271,  277,

      277,  277,  277,  277,  277,  277,  277,   69,  293,  294,
      295,  287,  278,  272,  273,  279,  281,  290,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  282,  288,  291,  293,  294,  295,
      296,  278,  289,  283,  279,  298,  284,  299,  302,  297,
      285,  306,  304,  309,  303,  292,  300,  310,  301,  305,
      658,  658,  658,  282,  288,  291,  658,  658,  311,  296,
      312,  289,  283,  313,  298,  284,  299,  302,  297,  285,
      306,  304,  309,  303,  292,  300,  310,  301,  305,  307,
      307,  307,  307,  307,  307,  307,  307,  311,  314,  312,

      315,  316,  313,  317,  308,  318,  319,  320,  186,  322,
      323,  324,  325,  326,  327,  328,  329,  332,  333,  187,
      187,  187,  187,  187,  187,  187,  187,  314,  330,  315,
      316,  331,  317,  308,  318,  319,  320,  334,  322,  323,
      324,  325,  326,  327,  328,  329,  332,  333,  335,  209,
      209,  209,  209,  209,  209,  209,  209,  330,  339,  340,
      331,  341,  342,  343,  344,  347,  334,  337,  337,  337,
      337,  337,  337,  337,  337,  348,  349,  335,  350,  351,
      352,  353,  354,  658,  658,  658,  658,  339,  340,  658,
      341,  342,  343,  344,  347,  355,  356,  357,  358,  359,

      360,  361,  338,  362,  348,  349,  363,  350,  351,  352,
      353,  354,  238,  238,  238,  238,  238,  238,  238,  238,
      364,  365,  369,  370,  355,  356,  357,  358,  359,  360,
      361,  338,  362,  366,  367,  363,  371,  372,  373,  374,
      375,  376,  368,  377,  378,  658,  658,  658,  658,  364,
      365,  369,  370,  277,  277,  277,  277,  277,  277,  277,
      277,  381,  366,  367,  382,  371,  372,  373,  374,  375,
      376,  368,  377,  378,  379,  379,  379,  379,  379,  379,
      379,  379,  380,  380,  380,  380,  380,  380,  380,  380,
      381,  383,  384,  382,  385,  386,  387,  388,  391,  393,

      394,  395,  396,  397,  398,  399,  400,  401,  402,  392,
      403,  404,  405,  389,  406,  407,  408,  409,  390,  658,
      383,  384,  658,  385,  386,  387,  388,  410,  393,  394,
      395,  396,  397,  398,  399,  400,  401,  402,  392,  403,
      404,  405,  389,  406,  407,  408,  409,  390,  307,  307,
      307,  307,  307,  307,  307,  307,  410,  411,  412,  413,
      415,  416,  425,  417,  420,  421,  418,  422,  658,  426,
      423,  427,  429,  337,  337,  337,  337,  337,  337,  337,
      337,  431,  432,  433,  434,  435,  411,  412,  413,  436,
      437,  425,  438,  419,  442,  443,  439,  424,  426,  444,

      427,  429,  440,  445,  446,  447,  448,  449,  450,  451,
      431,  432,  433,  434,  435,  452,  658,  658,  436,  437,
      658,  438,  419,  442,  443,  439,  424,  455,  444,  456,
      658,  440,  445,  446,  447,  448,  449,  450,  451,  658,
      658,  658,  658,  658,  452,  453,  453,  453,  453,  453,
      453,  453,  453,  457,  458,  460,  455,  658,  456,  379,
      379,  379,  379,  379,  379,  379,  379,  380,  380,  380,
      380,  380,  380,  380,  380,  461,  462,  463,  464,  465,
      466,  467,  457,  458,  460,  468,  454,  469,  470,  471,
      473,  476,  477,  478,  480,  481,  482,  486,  487,  490,

      491,  492,  494,  488,  461,  462,  463,  464,  465,  466,
      467,  489,  495,  496,  468,  497,  469,  470,  471,  473,
      476,  477,  478,  480,  481,  482,  486,  487,  490,  491,
      492,  494,  488,  498,  499,  500,  503,  504,  505,  506,
      489,  495,  496,  507,  497,  453,  453,  453,  453,  453,
      453,  453,  453,  508,  510,  511,  512,  509,  513,  514,
      515,  516,  498,  499,  500,  503,  504,  505,  506,  517,
      518,  519,  507,  520,  522,  523,  524,  525,  526,  527,
      528,  521,  508,  510,  511,  512,  509,  513,  514,  515,
      516,  529,  530,  531,  533,  534,  535,  536,  517,  518,

      519,  537,  520,  522,  523,  524,  525,  526,  527,  528,
      521,  538,  541,  542,  543,  544,  545,  546,  547,  548,
      529,  530,  531,  533,  534,  535,  536,  549,  551,  552,
      537,  553,  554,  555,  556,  557,  558,  562,  563,  564,
      538,  541,  542,  543,  544,  545,  546,  547,  548,  565,
      566,  567,  568,  569,  570,  571,  549,  551,  552,  572,
      553,  554,  555,  556,  557,  558,  562,  563,  564,  573,
      574,  575,  576,  577,  579,  580,  581,  582,  565,  566,
      567,  568,  569,  570,  571,  583,  584,  585,  572,  586,
      587,  588,  589,  590,  591,  592,  593,  594,  573,  574,

      575,  576,  577,  579,  580,  581,  582,  600,  601,  602,
      603,  604,  605,  606,  583,  584,  585,  595,  586,  587,
      588,  589,  590,  591,  592,  593,  594,  607,  608,  609,
      596,  610,  612,  613,  614,  615,  600,  601,  602,  603,
      604,  605,  606,  616,  617,  621,  595,  623,  624,  622,
      625,  626,  627,  628,  629,  630,  607,  608,  609,  596,
      610,  612,  613,  614,  615,  631,  632,  633,  634,  635,
      636,  637,  616,  617,  621,  638,  623,  624,  622,  625,
      626,  627,  628,  629,  630,  639,  640,  641,  642,  643,
      644,  645,  646,  648,  631,  632,  633,  634,  635,  636,

      637,  650,  651,  652,  638,  653,  654,  655,  656,  657,
      658,  658,  658,  658,  639,  640,  641,  642,  643,  644,
      645,  646,  648,  658,  658,  658,  658,  658,  658,  658,
      650,  651,  652,  658,  653,  654,  655,  656,  657,   58,
       58,   58,   58,   62,   62,   62,   62,   63,   63,   63,
       63,  100,  100,  188,  658,  188,  188,  206,  206,  206,
      206,  483,  483,  483,  483,  559,  559,  559,  559,  597,
      597,  597,  597,  618,  618,  618,  618,   11,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,

      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658
    } ;

static yyconst flex_int16_t yy_chk[1664] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    3,    3,    4,    4,    5,
       16,   15,    3,    6,    4,    7,    7,    7,    7,    7,

        7,    7,    7,    8,    8,    8,    8,    8,    8,    8,
        8,   13,   13,  666,   13,   14,   14,   15,   14,   16,
       21,   21,   21,   21,   21,   21,   21,   21,   23,   70,
       70,  665,   70,   23,   89,   89,   38,    5,    5,    5,
        5,    6,    6,    6,    6,   24,   15,   24,   24,   24,
       24,   24,   24,   24,   24,   25,  646,   25,   25,   25,
       25,   25,   25,   25,   25,   38,    5,    5,    5,    5,
        6,    6,    6,    6,   22,   40,   22,   22,   22,   45,
       22,   32,   53,   24,   22,   22,   32,   22,   22,  206,
      206,   22,   22,  644,   22,  601,   72,  556,   32,   22,

      208,  208,  518,   22,   40,   22,   22,   22,   45,   22,
       32,   53,   24,   22,   22,   32,   22,   22,   33,   33,
       22,   22,   26,   22,   26,   72,   26,   32,   22,   39,
       33,   46,   33,   73,   46,   33,   39,   39,  502,   39,
       46,   26,   26,   26,  226,  226,  501,   33,   33,  425,
      425,   26,  493,   26,   76,   26,  474,   77,   39,   33,
       46,   33,   73,   46,   33,   39,   39,   34,   39,   46,
       26,   26,   26,   31,   31,   31,   31,   31,   31,   31,
       31,   34,   34,   76,   49,   34,   77,   78,   31,   31,
       35,   79,   35,   35,   49,   80,   34,   31,   31,   31,

       81,   49,   35,   84,   31,   31,   85,   31,  483,  483,
       34,   34,  446,   49,   34,  445,   78,   31,   31,   35,
       79,   35,   35,   49,   80,  432,   31,   31,   31,   81,
       49,   35,   84,   31,   31,   85,   31,   36,   36,   36,
       36,   36,   36,   36,   36,   75,   97,   75,  420,  101,
       82,   36,   37,   37,   37,   37,   37,   37,   37,   37,
       42,   51,  102,  104,   42,   37,   42,   36,   51,   42,
       68,   82,  105,  106,   75,   97,   75,   42,  101,   82,
       36,   68,   68,   68,   68,   68,   68,   68,   68,   42,
       51,  102,  104,   42,   37,   42,   36,   51,   42,  415,

       82,  105,  106,  485,  485,  413,   42,   43,   43,   43,
       43,   43,   43,   43,   43,  107,  108,  529,  529,  411,
       43,   44,   44,   44,   44,   44,   44,   44,   44,  109,
       50,   43,   50,  103,   43,   52,  103,   43,   43,  112,
       43,  113,   52,  117,  107,  108,   50,   50,   44,   43,
      120,   50,   52,  122,   44,  559,  559,  392,  109,   50,
       43,   50,  103,   43,   52,  103,   43,   43,  112,   43,
      113,   52,  117,  561,  561,   50,   50,   44,  123,  120,
       50,   52,  122,   44,   47,   47,   47,   47,   47,   47,
       47,   47,   71,   96,   71,   96,  124,  114,  110,  121,

       71,   47,  110,  111,  111,  111,  355,  123,   47,  129,
       47,  110,  114,  121,   96,   47,  334,  119,  119,  119,
      332,   71,   96,   71,   96,  124,  114,  110,  121,   71,
       47,  110,  111,  111,  111,  119,  326,   47,  129,   47,
      110,  114,  121,   96,   47,   48,  131,   48,  132,   48,
      115,  115,   48,   48,  128,  133,  115,  135,  128,  135,
      137,   48,   48,  138,  119,   48,  188,   48,  579,  579,
      597,  597,  599,  599,   48,  131,   48,  132,   48,  115,
      115,   48,   48,  128,  133,  115,  135,  128,  135,  137,
       48,   48,  138,  186,   48,   74,   48,   74,   74,   74,

       74,   74,   74,   74,   74,   90,   90,   90,   90,   90,
       90,   90,   90,   91,  127,   91,   91,   91,   91,   91,
       91,   91,   91,   99,   99,   99,   99,   99,   99,   99,
       99,  116,  116,  116,  116,  116,  116,  116,  116,  130,
      130,  130,  130,  130,  130,  130,  130,  134,  116,  139,
      140,  141,  142,  143,  143,  143,  143,  143,  143,  143,
      143,  145,  146,  147,  149,  134,  153,  139,  144,  144,
      610,  610,  618,  618,  620,  620,  134,  116,  139,  140,
      141,  142,  155,  126,  144,  144,   61,   11,  157,   10,
      145,  146,  147,  149,  134,  153,  139,  144,  144,  148,

      148,  148,  148,  148,  148,  148,  148,    9,  159,  160,
      161,  155,  148,  144,  144,  148,  150,  157,  150,  150,
      150,  150,  150,  150,  150,  150,  151,  151,  151,  151,
      151,  151,  151,  151,  152,  156,  158,  159,  160,  161,
      162,  148,  156,  152,  148,  163,  152,  164,  165,  162,
      152,  167,  166,  169,  165,  158,  164,  170,  164,  166,
        0,    0,    0,  152,  156,  158,    0,    0,  171,  162,
      172,  156,  152,  173,  163,  152,  164,  165,  162,  152,
      167,  166,  169,  165,  158,  164,  170,  164,  166,  168,
      168,  168,  168,  168,  168,  168,  168,  171,  176,  172,

      177,  180,  173,  181,  168,  182,  183,  184,  187,  189,
      190,  191,  192,  193,  194,  195,  196,  198,  200,  187,
      187,  187,  187,  187,  187,  187,  187,  176,  197,  177,
      180,  197,  181,  168,  182,  183,  184,  204,  189,  190,
      191,  192,  193,  194,  195,  196,  198,  200,  205,  209,
      209,  209,  209,  209,  209,  209,  209,  197,  216,  217,
      197,  218,  219,  222,  224,  227,  204,  215,  215,  215,
      215,  215,  215,  215,  215,  230,  231,  205,  232,  233,
      234,  235,  236,    0,    0,    0,    0,  216,  217,    0,
      218,  219,  222,  224,  227,  240,  245,  246,  247,  248,

      251,  252,  215,  256,  230,  231,  257,  232,  233,  234,
      235,  236,  238,  238,  238,  238,  238,  238,  238,  238,
      259,  260,  263,  264,  240,  245,  246,  247,  248,  251,
      252,  215,  256,  261,  261,  257,  265,  266,  270,  272,
      273,  274,  261,  276,  278,    0,    0,    0,    0,  259,
      260,  263,  264,  277,  277,  277,  277,  277,  277,  277,
      277,  282,  261,  261,  283,  265,  266,  270,  272,  273,
      274,  261,  276,  278,  279,  279,  279,  279,  279,  279,
      279,  279,  281,  281,  281,  281,  281,  281,  281,  281,
      282,  286,  290,  283,  291,  293,  294,  294,  296,  297,

      298,  299,  301,  304,  305,  306,  308,  309,  310,  296,
      311,  312,  313,  294,  315,  317,  318,  319,  294,    0,
      286,  290,    0,  291,  293,  294,  294,  322,  297,  298,
      299,  301,  304,  305,  306,  308,  309,  310,  296,  311,
      312,  313,  294,  315,  317,  318,  319,  294,  307,  307,
      307,  307,  307,  307,  307,  307,  322,  323,  324,  325,
      327,  327,  329,  327,  328,  328,  327,  328,    0,  330,
      328,  331,  333,  337,  337,  337,  337,  337,  337,  337,
      337,  338,  340,  341,  342,  343,  323,  324,  325,  347,
      348,  329,  351,  327,  356,  357,  353,  328,  330,  359,

      331,  333,  353,  360,  361,  362,  364,  366,  367,  368,
      338,  340,  341,  342,  343,  371,    0,    0,  347,  348,
        0,  351,  327,  356,  357,  353,  328,  377,  359,  378,
        0,  353,  360,  361,  362,  364,  366,  367,  368,    0,
        0,    0,    0,    0,  371,  374,  374,  374,  374,  374,
      374,  374,  374,  381,  382,  393,  377,    0,  378,  379,
      379,  379,  379,  379,  379,  379,  379,  380,  380,  380,
      380,  380,  380,  380,  380,  394,  395,  397,  398,  400,
      402,  403,  381,  382,  393,  404,  374,  408,  409,  410,
      412,  416,  417,  418,  421,  422,  423,  426,  427,  429,

      430,  431,  433,  428,  394,  395,  397,  398,  400,  402,
      403,  428,  435,  437,  404,  439,  408,  409,  410,  412,
      416,  417,  418,  421,  422,  423,  426,  427,  429,  430,
      431,  433,  428,  441,  442,  443,  447,  449,  450,  451,
      428,  435,  437,  454,  439,  453,  453,  453,  453,  453,
      453,  453,  453,  457,  458,  460,  461,  457,  462,  463,
      464,  465,  441,  442,  443,  447,  449,  450,  451,  466,
      467,  468,  454,  472,  473,  475,  479,  486,  487,  488,
      489,  472,  457,  458,  460,  461,  457,  462,  463,  464,
      465,  490,  491,  492,  494,  496,  497,  498,  466,  467,

      468,  499,  472,  473,  475,  479,  486,  487,  488,  489,
      472,  500,  503,  504,  505,  507,  508,  509,  511,  513,
      490,  491,  492,  494,  496,  497,  498,  516,  519,  520,
      499,  521,  522,  525,  526,  527,  528,  530,  531,  533,
      500,  503,  504,  505,  507,  508,  509,  511,  513,  534,
      535,  536,  537,  538,  542,  543,  516,  519,  520,  544,
      521,  522,  525,  526,  527,  528,  530,  531,  533,  549,
      550,  551,  552,  553,  557,  558,  562,  563,  534,  535,
      536,  537,  538,  542,  543,  565,  567,  568,  544,  569,
      570,  571,  572,  573,  574,  575,  576,  577,  549,  550,

      551,  552,  553,  557,  558,  562,  563,  580,  581,  583,
      586,  588,  589,  591,  565,  567,  568,  578,  569,  570,
      571,  572,  573,  574,  575,  576,  577,  594,  595,  596,
      578,  600,  603,  605,  606,  607,  580,  581,  583,  586,
      588,  589,  591,  608,  609,  611,  578,  613,  614,  611,
      616,  617,  621,  622,  624,  625,  594,  595,  596,  578,
      600,  603,  605,  606,  607,  626,  627,  628,  629,  630,
      631,  632,  608,  609,  611,  633,  613,  614,  611,  616,
      617,  621,  622,  624,  625,  635,  636,  637,  638,  639,
      640,  641,  643,  645,  626,  627,  628,  629,  630,  631,

      632,  647,  649,  650,  633,  651,  652,  653,  654,  655,
        0,    0,    0,    0,  635,  636,  637,  638,  639,  640,
      641,  643,  645,    0,    0,    0,    0,    0,    0,    0,
      647,  649,  650,    0,  651,  652,  653,  654,  655,  659,
      659,  659,  659,  660,  660,  660,  660,  661,  661,  661,
      661,  662,  662,  663,    0,  663,  663,  664,  664,  664,
      664,  667,  667,  667,  667,  668,  668,  668,  668,  669,
      669,  669,  669,  670,  670,  670,  670,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,

      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[229] =
    {   0,
1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lex.l"
#line 3 "lex.l"
#include <string.h>
#include "gen4asm.h"
#include "gram.h"
#include "brw_defines.h"

#include "string.h"
int saved_state = 0;
extern char *input_filename;





#line 1088 "lex.c"

#define INITIAL 0
#define BLOCK_COMMENT 1
#define CHANNEL 2
#define LINENUMBER 3
#define FILENAME 4

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

    static void yyunput (int c,char *buf_ptr  );
    
#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 18 "lex.l"

#line 1281 "lex.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 659 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 1578 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 19 "lex.l"
{ } /* eat up single-line comments */
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 20 "lex.l"
{ }
	YY_BREAK
case 3:
/* rule 3 can match eol */
YY_RULE_SETUP
#line 21 "lex.l"
{ }
	YY_BREAK
case 4:
/* rule 4 can match eol */
YY_RULE_SETUP
#line 22 "lex.l"
{ }
	YY_BREAK
case 5:
/* rule 5 can match eol */
YY_RULE_SETUP
#line 23 "lex.l"
{ }
	YY_BREAK
/* eat up multi-line comments, non-nesting. */
case 6:
YY_RULE_SETUP
#line 26 "lex.l"
{
	saved_state = YYSTATE;
	BEGIN(BLOCK_COMMENT);
}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 30 "lex.l"
{
	BEGIN(saved_state);
}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 33 "lex.l"
{ }
	YY_BREAK
case 9:
/* rule 9 can match eol */
YY_RULE_SETUP
#line 34 "lex.l"
{ }
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 35 "lex.l"
{ 
	saved_state = YYSTATE;
	BEGIN(LINENUMBER);
}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 39 "lex.l"
{
	yylineno = atoi (yytext) - 1;
	BEGIN(FILENAME);
}
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 43 "lex.l"
{
	char *name = malloc (yyleng - 1);
	memmove (name, yytext + 1, yyleng - 2);
	name[yyleng-1] = '\0';
	input_filename = name;
	BEGIN(saved_state);
}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 51 "lex.l"
{
	yylval.integer = BRW_CHANNEL_X;
	return X;
}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 55 "lex.l"
{
	yylval.integer = BRW_CHANNEL_Y;
	return Y;
}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 59 "lex.l"
{
	yylval.integer = BRW_CHANNEL_Z;
	return Z;
}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 63 "lex.l"
{
yylval.integer = BRW_CHANNEL_W;
	return W;
}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 67 "lex.l"
{
	yyless(0);
	BEGIN(INITIAL);
}
	YY_BREAK
/* used for both null send and null register. */
case 18:
YY_RULE_SETUP
#line 73 "lex.l"
{ return NULL_TOKEN; }
	YY_BREAK
/* opcodes */
case 19:
YY_RULE_SETUP
#line 76 "lex.l"
{ yylval.integer = BRW_OPCODE_MOV; return MOV; }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 77 "lex.l"
{ yylval.integer = BRW_OPCODE_FRC; return FRC; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 78 "lex.l"
{ yylval.integer = BRW_OPCODE_RNDU; return RNDU; }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 79 "lex.l"
{ yylval.integer = BRW_OPCODE_RNDD; return RNDD; }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 80 "lex.l"
{ yylval.integer = BRW_OPCODE_RNDE; return RNDE; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 81 "lex.l"
{ yylval.integer = BRW_OPCODE_RNDZ; return RNDZ; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 82 "lex.l"
{ yylval.integer = BRW_OPCODE_NOT; return NOT; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 83 "lex.l"
{ yylval.integer = BRW_OPCODE_LZD; return LZD; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 84 "lex.l"
{ yylval.integer = BRW_OPCODE_F16TO32; return F16TO32; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 85 "lex.l"
{ yylval.integer = BRW_OPCODE_F32TO16; return F32TO16; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 86 "lex.l"
{ yylval.integer = BRW_OPCODE_FBH; return FBH; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 87 "lex.l"
{ yylval.integer = BRW_OPCODE_FBL; return FBL; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 89 "lex.l"
{ yylval.integer = BRW_OPCODE_MAD; return MAD; }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 90 "lex.l"
{ yylval.integer = BRW_OPCODE_LRP; return LRP; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 91 "lex.l"
{ yylval.integer = BRW_OPCODE_BFE; return BFE; }
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 92 "lex.l"
{ yylval.integer = BRW_OPCODE_BFI1; return BFI1; }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 93 "lex.l"
{ yylval.integer = BRW_OPCODE_BFI2; return BFI2; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 94 "lex.l"
{ yylval.integer = BRW_OPCODE_BFREV; return BFREV; }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 95 "lex.l"
{ yylval.integer = BRW_OPCODE_MUL; return MUL; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 96 "lex.l"
{ yylval.integer = BRW_OPCODE_MAC; return MAC; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 97 "lex.l"
{ yylval.integer = BRW_OPCODE_MACH; return MACH; }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 98 "lex.l"
{ yylval.integer = BRW_OPCODE_LINE; return LINE; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 99 "lex.l"
{ yylval.integer = BRW_OPCODE_SAD2; return SAD2; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 100 "lex.l"
{ yylval.integer = BRW_OPCODE_SADA2; return SADA2; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 101 "lex.l"
{ yylval.integer = BRW_OPCODE_DP4; return DP4; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 102 "lex.l"
{ yylval.integer = BRW_OPCODE_DPH; return DPH; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 103 "lex.l"
{ yylval.integer = BRW_OPCODE_DP3; return DP3; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 104 "lex.l"
{ yylval.integer = BRW_OPCODE_DP2; return DP2; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 106 "lex.l"
{ yylval.integer = BRW_OPCODE_CBIT; return CBIT; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 107 "lex.l"
{ yylval.integer = BRW_OPCODE_AVG; return AVG; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 108 "lex.l"
{ yylval.integer = BRW_OPCODE_ADD; return ADD; }
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 109 "lex.l"
{ yylval.integer = BRW_OPCODE_ADDC; return ADDC; }
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 110 "lex.l"
{ yylval.integer = BRW_OPCODE_SEL; return SEL; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 111 "lex.l"
{ yylval.integer = BRW_OPCODE_AND; return AND; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 112 "lex.l"
{ yylval.integer = BRW_OPCODE_OR; return OR; }
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 113 "lex.l"
{ yylval.integer = BRW_OPCODE_XOR; return XOR; }
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 114 "lex.l"
{ yylval.integer = BRW_OPCODE_SHR; return SHR; }
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 115 "lex.l"
{ yylval.integer = BRW_OPCODE_SHL; return SHL; }
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 116 "lex.l"
{ yylval.integer = BRW_OPCODE_ASR; return ASR; }
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 117 "lex.l"
{ yylval.integer = BRW_OPCODE_CMP; return CMP; }
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 118 "lex.l"
{ yylval.integer = BRW_OPCODE_CMPN; return CMPN; }
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 119 "lex.l"
{ yylval.integer = BRW_OPCODE_SUBB; return SUBB; }
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 121 "lex.l"
{ yylval.integer = BRW_OPCODE_SEND; return SEND; }
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 122 "lex.l"
{ yylval.integer = BRW_OPCODE_NOP; return NOP; }
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 123 "lex.l"
{ yylval.integer = BRW_OPCODE_JMPI; return JMPI; }
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 124 "lex.l"
{ yylval.integer = BRW_OPCODE_IF; return IF; }
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 125 "lex.l"
{ yylval.integer = BRW_OPCODE_IFF; return IFF; }
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 126 "lex.l"
{ yylval.integer = BRW_OPCODE_WHILE; return WHILE; }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 127 "lex.l"
{ yylval.integer = BRW_OPCODE_ELSE; return ELSE; }
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 128 "lex.l"
{ yylval.integer = BRW_OPCODE_BREAK; return BREAK; }
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 129 "lex.l"
{ yylval.integer = BRW_OPCODE_CONTINUE; return CONT; }
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 130 "lex.l"
{ yylval.integer = BRW_OPCODE_HALT; return HALT; }
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 131 "lex.l"
{ yylval.integer = BRW_OPCODE_MSAVE; return MSAVE; }
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 132 "lex.l"
{ yylval.integer = BRW_OPCODE_PUSH; return PUSH; }
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 133 "lex.l"
{ yylval.integer = BRW_OPCODE_MRESTORE; return MREST; }
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 134 "lex.l"
{ yylval.integer = BRW_OPCODE_POP; return POP; }
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 135 "lex.l"
{ yylval.integer = BRW_OPCODE_WAIT; return WAIT; }
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 136 "lex.l"
{ yylval.integer = BRW_OPCODE_DO; return DO; }
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 137 "lex.l"
{ yylval.integer = BRW_OPCODE_ENDIF; return ENDIF; }
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 138 "lex.l"
{ yylval.integer = BRW_OPCODE_CALL; return CALL; }
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 139 "lex.l"
{ yylval.integer = BRW_OPCODE_RET; return RET; }
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 140 "lex.l"
{ yylval.integer = BRW_OPCODE_BRD; return BRD; }
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 141 "lex.l"
{ yylval.integer = BRW_OPCODE_BRC; return BRC; }
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 143 "lex.l"
{ yylval.integer = BRW_OPCODE_PLN; return PLN; }
	YY_BREAK
/* send argument tokens */
case 83:
YY_RULE_SETUP
#line 146 "lex.l"
{ return MSGLEN; }
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 147 "lex.l"
{ return RETURNLEN; }
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 148 "lex.l"
{ if (IS_GENp(6)) { yylval.integer = BRW_OPCODE_MATH; return MATH_INST; } else return MATH; }
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 149 "lex.l"
{ return SAMPLER; }
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 150 "lex.l"
{ return GATEWAY; }
	YY_BREAK
case 88:
YY_RULE_SETUP
#line 151 "lex.l"
{ return READ; }
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 152 "lex.l"
{ return WRITE; }
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 153 "lex.l"
{ return URB; }
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 154 "lex.l"
{ return THREAD_SPAWNER; }
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 155 "lex.l"
{ return VME; }
	YY_BREAK
case 93:
YY_RULE_SETUP
#line 156 "lex.l"
{ return CRE; }
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 157 "lex.l"
{ return DATA_PORT; }
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 159 "lex.l"
{ return ALLOCATE; }
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 160 "lex.l"
{ return USED; }
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 161 "lex.l"
{ return COMPLETE; }
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 162 "lex.l"
{ return TRANSPOSE; }
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 163 "lex.l"
{ return INTERLEAVE; }
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 165 "lex.l"
{ return SEMICOLON; }
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 166 "lex.l"
{ return LPAREN; }
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 167 "lex.l"
{ return RPAREN; }
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 168 "lex.l"
{ return LANGLE; }
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 169 "lex.l"
{ return RANGLE; }
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 170 "lex.l"
{ return LCURLY; }
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 171 "lex.l"
{ return RCURLY; }
	YY_BREAK
case 107:
YY_RULE_SETUP
#line 172 "lex.l"
{ return LSQUARE; }
	YY_BREAK
case 108:
YY_RULE_SETUP
#line 173 "lex.l"
{ return RSQUARE; }
	YY_BREAK
case 109:
YY_RULE_SETUP
#line 174 "lex.l"
{ return COMMA; }
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 175 "lex.l"
{ BEGIN(CHANNEL); return DOT; }
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 176 "lex.l"
{ return PLUS; }
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 177 "lex.l"
{ return MINUS; }
	YY_BREAK
case 113:
YY_RULE_SETUP
#line 178 "lex.l"
{ return MULTIPLY;}
	YY_BREAK
case 114:
YY_RULE_SETUP
#line 179 "lex.l"
{ return DIVIDE; }
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 180 "lex.l"
{ return COLON; }
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 181 "lex.l"
{ return EQ; }
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 182 "lex.l"
{ return ABS; }
	YY_BREAK
/* Most register accesses are lexed as REGFILE[0-9]+, to prevent the register
  * with subreg from being lexed as REGFILE NUMBER instead of
  * REGISTER INTEGER DOT INTEGER like we want.  The alternative was to use a
  * start condition, which wasn't very clean-looking.
  *
  * However, this means we need to lex the general and message register file
  * characters as well, for register-indirect access which is formatted
  * like g[a#.#] or m[a#.#].
  */
case 118:
YY_RULE_SETUP
#line 193 "lex.l"
{
	yylval.integer = atoi(yytext + 3);
	return ACCREG;
}
	YY_BREAK
case 119:
YY_RULE_SETUP
#line 197 "lex.l"
{
	yylval.integer = atoi(yytext + 1);
	return ADDRESSREG;
}
	YY_BREAK
case 120:
YY_RULE_SETUP
#line 201 "lex.l"
{
	yylval.integer = atoi(yytext + 1);
	return MSGREG;
}
	YY_BREAK
case 121:
YY_RULE_SETUP
#line 205 "lex.l"
{
	return MSGREGFILE;
}
	YY_BREAK
case 122:
YY_RULE_SETUP
#line 208 "lex.l"
{
	yylval.integer = atoi(yytext + 4);
	return MASKREG;
}
	YY_BREAK
case 123:
YY_RULE_SETUP
#line 212 "lex.l"
{
	yylval.integer = atoi(yytext + 2);
	return MASKSTACKREG;
}
	YY_BREAK
case 124:
YY_RULE_SETUP
#line 216 "lex.l"
{
	yylval.integer = atoi(yytext + 3);
	return MASKSTACKDEPTHREG;
}
	YY_BREAK
case 125:
YY_RULE_SETUP
#line 221 "lex.l"
{
	yylval.integer = atoi(yytext + 3);
	return NOTIFYREG;
}
	YY_BREAK
case 126:
YY_RULE_SETUP
#line 226 "lex.l"
{
	yylval.integer = atoi(yytext + 1);
	return NOTIFYREG;
}
	YY_BREAK
case 127:
YY_RULE_SETUP
#line 231 "lex.l"
{
	yylval.integer = atoi(yytext + 1);
	return FLAGREG;
}
	YY_BREAK
case 128:
YY_RULE_SETUP
#line 236 "lex.l"
{
	yylval.integer = atoi(yytext + 1);
	return GENREG;
}
	YY_BREAK
case 129:
YY_RULE_SETUP
#line 240 "lex.l"
{
	return GENREGFILE;
}
	YY_BREAK
case 130:
YY_RULE_SETUP
#line 243 "lex.l"
{
	yylval.integer = atoi(yytext + 2);
	return CONTROLREG;
}
	YY_BREAK
case 131:
YY_RULE_SETUP
#line 247 "lex.l"
{
	yylval.integer = atoi(yytext + 2);
	return STATEREG;
}
	YY_BREAK
case 132:
YY_RULE_SETUP
#line 251 "lex.l"
{
	return IPREG;
}
	YY_BREAK
case 133:
YY_RULE_SETUP
#line 254 "lex.l"
{
	yylval.integer = BRW_AMASK;
	return AMASK;
}
	YY_BREAK
case 134:
YY_RULE_SETUP
#line 258 "lex.l"
{
	yylval.integer = BRW_IMASK;
	return IMASK;
}
	YY_BREAK
case 135:
YY_RULE_SETUP
#line 262 "lex.l"
{
	yylval.integer = BRW_LMASK;
	return LMASK;
}
	YY_BREAK
case 136:
YY_RULE_SETUP
#line 266 "lex.l"
{
	yylval.integer = BRW_CMASK;
	return CMASK;
}
	YY_BREAK
case 137:
YY_RULE_SETUP
#line 270 "lex.l"
{
	yylval.integer = 0;
	return IMSD;
}
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 274 "lex.l"
{
	yylval.integer = 1;
	return LMSD;
}
	YY_BREAK
case 139:
YY_RULE_SETUP
#line 278 "lex.l"
{
	yylval.integer = 0;
	return IMS;
}
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 282 "lex.l"
{
	yylval.integer = 16;
	return LMS;
}
	YY_BREAK
/*
  * Lexing of register types should probably require the ":" symbol specified
  * in the BNF of the assembly, but our existing source didn't use that syntax.
  */
case 141:
YY_RULE_SETUP
#line 291 "lex.l"
{ return TYPE_UD; }
	YY_BREAK
case 142:
YY_RULE_SETUP
#line 292 "lex.l"
{ return TYPE_UD; }
	YY_BREAK
case 143:
YY_RULE_SETUP
#line 293 "lex.l"
{ return TYPE_D; }
	YY_BREAK
case 144:
YY_RULE_SETUP
#line 294 "lex.l"
{ return TYPE_D; }
	YY_BREAK
case 145:
YY_RULE_SETUP
#line 295 "lex.l"
{ return TYPE_UW; }
	YY_BREAK
case 146:
YY_RULE_SETUP
#line 296 "lex.l"
{ return TYPE_UW; }
	YY_BREAK
case 147:
YY_RULE_SETUP
#line 297 "lex.l"
{ return TYPE_W; }
	YY_BREAK
case 148:
YY_RULE_SETUP
#line 298 "lex.l"
{ return TYPE_W; }
	YY_BREAK
case 149:
YY_RULE_SETUP
#line 299 "lex.l"
{ return TYPE_UB; }
	YY_BREAK
case 150:
YY_RULE_SETUP
#line 300 "lex.l"
{ return TYPE_UB; }
	YY_BREAK
case 151:
YY_RULE_SETUP
#line 301 "lex.l"
{ return TYPE_B; }
	YY_BREAK
case 152:
YY_RULE_SETUP
#line 302 "lex.l"
{ return TYPE_B; }
	YY_BREAK
case 153:
YY_RULE_SETUP
#line 303 "lex.l"
{ return TYPE_F; }
	YY_BREAK
case 154:
YY_RULE_SETUP
#line 304 "lex.l"
{ return TYPE_F; }
	YY_BREAK
case 155:
YY_RULE_SETUP
#line 305 "lex.l"
{return TYPE_VF; }
	YY_BREAK
case 156:
YY_RULE_SETUP
#line 306 "lex.l"
{return TYPE_VF; }
	YY_BREAK
case 157:
YY_RULE_SETUP
#line 307 "lex.l"
{ return TYPE_V; }
	YY_BREAK
case 158:
YY_RULE_SETUP
#line 308 "lex.l"
{ return TYPE_V; }
	YY_BREAK
case 159:
YY_RULE_SETUP
#line 310 "lex.l"
{ return KERNEL_PRAGMA;}
	YY_BREAK
case 160:
YY_RULE_SETUP
#line 311 "lex.l"
{ return END_KERNEL_PRAGMA;}
	YY_BREAK
case 161:
YY_RULE_SETUP
#line 312 "lex.l"
{ return CODE_PRAGMA;}
	YY_BREAK
case 162:
YY_RULE_SETUP
#line 313 "lex.l"
{ return END_CODE_PRAGMA;}
	YY_BREAK
case 163:
YY_RULE_SETUP
#line 314 "lex.l"
{ return REG_COUNT_PAYLOAD_PRAGMA; }
	YY_BREAK
case 164:
YY_RULE_SETUP
#line 315 "lex.l"
{ return REG_COUNT_TOTAL_PRAGMA; }
	YY_BREAK
case 165:
YY_RULE_SETUP
#line 316 "lex.l"
{ return DEFAULT_EXEC_SIZE_PRAGMA; }
	YY_BREAK
case 166:
YY_RULE_SETUP
#line 317 "lex.l"
{ return DEFAULT_REG_TYPE_PRAGMA; }
	YY_BREAK
case 167:
YY_RULE_SETUP
#line 318 "lex.l"
{ return DECLARE_PRAGMA; }
	YY_BREAK
case 168:
YY_RULE_SETUP
#line 319 "lex.l"
{ return BASE; }
	YY_BREAK
case 169:
YY_RULE_SETUP
#line 320 "lex.l"
{ return ELEMENTSIZE; }
	YY_BREAK
case 170:
YY_RULE_SETUP
#line 321 "lex.l"
{ return SRCREGION; }
	YY_BREAK
case 171:
YY_RULE_SETUP
#line 322 "lex.l"
{ return DSTREGION; }
	YY_BREAK
case 172:
YY_RULE_SETUP
#line 323 "lex.l"
{ return TYPE; }
	YY_BREAK
case 173:
YY_RULE_SETUP
#line 326 "lex.l"
{ return SATURATE; }
	YY_BREAK
case 174:
YY_RULE_SETUP
#line 327 "lex.l"
{ return ALIGN1; }
	YY_BREAK
case 175:
YY_RULE_SETUP
#line 328 "lex.l"
{ return ALIGN16; }
	YY_BREAK
case 176:
YY_RULE_SETUP
#line 329 "lex.l"
{ return SECHALF; }
	YY_BREAK
case 177:
YY_RULE_SETUP
#line 330 "lex.l"
{ return COMPR; }
	YY_BREAK
case 178:
YY_RULE_SETUP
#line 331 "lex.l"
{ return SWITCH; }
	YY_BREAK
case 179:
YY_RULE_SETUP
#line 332 "lex.l"
{ return ATOMIC; }
	YY_BREAK
case 180:
YY_RULE_SETUP
#line 333 "lex.l"
{ return NODDCHK; }
	YY_BREAK
case 181:
YY_RULE_SETUP
#line 334 "lex.l"
{ return NODDCLR; }
	YY_BREAK
case 182:
YY_RULE_SETUP
#line 335 "lex.l"
{ return MASK_DISABLE; }
	YY_BREAK
case 183:
YY_RULE_SETUP
#line 336 "lex.l"
{ return MASK_DISABLE; }
	YY_BREAK
case 184:
YY_RULE_SETUP
#line 337 "lex.l"
{ return BREAKPOINT; }
	YY_BREAK
case 185:
YY_RULE_SETUP
#line 338 "lex.l"
{ return ACCWRCTRL; }
	YY_BREAK
case 186:
YY_RULE_SETUP
#line 339 "lex.l"
{ return EOT; }
	YY_BREAK
/* extended math functions */
case 187:
YY_RULE_SETUP
#line 342 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_INV; return SIN; }
	YY_BREAK
case 188:
YY_RULE_SETUP
#line 343 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_LOG; return LOG; }
	YY_BREAK
case 189:
YY_RULE_SETUP
#line 344 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_EXP; return EXP; }
	YY_BREAK
case 190:
YY_RULE_SETUP
#line 345 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_SQRT; return SQRT; }
	YY_BREAK
case 191:
YY_RULE_SETUP
#line 346 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_RSQ; return RSQ; }
	YY_BREAK
case 192:
YY_RULE_SETUP
#line 347 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_POW; return POW; }
	YY_BREAK
case 193:
YY_RULE_SETUP
#line 348 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_SIN; return SIN; }
	YY_BREAK
case 194:
YY_RULE_SETUP
#line 349 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_COS; return COS; }
	YY_BREAK
case 195:
YY_RULE_SETUP
#line 350 "lex.l"
{ yylval.integer = BRW_MATH_FUNCTION_SINCOS; return SINCOS; }
	YY_BREAK
case 196:
YY_RULE_SETUP
#line 351 "lex.l"
{
	yylval.integer = BRW_MATH_FUNCTION_INT_DIV_QUOTIENT;
	return INTDIV;
}
	YY_BREAK
case 197:
YY_RULE_SETUP
#line 355 "lex.l"
{
	yylval.integer = BRW_MATH_FUNCTION_INT_DIV_REMAINDER;
	return INTMOD;
}
	YY_BREAK
case 198:
YY_RULE_SETUP
#line 359 "lex.l"
{
	yylval.integer = BRW_MATH_FUNCTION_INT_DIV_QUOTIENT_AND_REMAINDER;
	return INTDIVMOD;
}
	YY_BREAK
case 199:
YY_RULE_SETUP
#line 364 "lex.l"
{ return SIGNED; }
	YY_BREAK
case 200:
YY_RULE_SETUP
#line 365 "lex.l"
{ return SCALAR; }
	YY_BREAK
/* predicate control */
case 201:
YY_RULE_SETUP
#line 368 "lex.l"
{ return ANYV; }
	YY_BREAK
case 202:
YY_RULE_SETUP
#line 369 "lex.l"
{ return ALLV; }
	YY_BREAK
case 203:
YY_RULE_SETUP
#line 370 "lex.l"
{ return ANY2H; }
	YY_BREAK
case 204:
YY_RULE_SETUP
#line 371 "lex.l"
{ return ALL2H; }
	YY_BREAK
case 205:
YY_RULE_SETUP
#line 372 "lex.l"
{ return ANY4H; }
	YY_BREAK
case 206:
YY_RULE_SETUP
#line 373 "lex.l"
{ return ALL4H; }
	YY_BREAK
case 207:
YY_RULE_SETUP
#line 374 "lex.l"
{ return ANY8H; }
	YY_BREAK
case 208:
YY_RULE_SETUP
#line 375 "lex.l"
{ return ALL8H; }
	YY_BREAK
case 209:
YY_RULE_SETUP
#line 376 "lex.l"
{ return ANY16H; }
	YY_BREAK
case 210:
YY_RULE_SETUP
#line 377 "lex.l"
{ return ALL16H; }
	YY_BREAK
case 211:
YY_RULE_SETUP
#line 379 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_Z; return ZERO; }
	YY_BREAK
case 212:
YY_RULE_SETUP
#line 380 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_Z; return EQUAL; }
	YY_BREAK
case 213:
YY_RULE_SETUP
#line 381 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_NZ; return NOT_ZERO; }
	YY_BREAK
case 214:
YY_RULE_SETUP
#line 382 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_NZ; return NOT_EQUAL; }
	YY_BREAK
case 215:
YY_RULE_SETUP
#line 383 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_G; return GREATER; }
	YY_BREAK
case 216:
YY_RULE_SETUP
#line 384 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_GE; return GREATER_EQUAL; }
	YY_BREAK
case 217:
YY_RULE_SETUP
#line 385 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_L; return LESS; }
	YY_BREAK
case 218:
YY_RULE_SETUP
#line 386 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_LE; return LESS_EQUAL; }
	YY_BREAK
case 219:
YY_RULE_SETUP
#line 387 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_R; return ROUND_INCREMENT; }
	YY_BREAK
case 220:
YY_RULE_SETUP
#line 388 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_O; return OVERFLOW; }
	YY_BREAK
case 221:
YY_RULE_SETUP
#line 389 "lex.l"
{ yylval.integer = BRW_CONDITIONAL_U; return UNORDERED; }
	YY_BREAK
case 222:
YY_RULE_SETUP
#line 391 "lex.l"
{
           yylval.string = strdup(yytext);
           return STRING;
}
	YY_BREAK
case 223:
YY_RULE_SETUP
#line 396 "lex.l"
{
	yylval.integer = strtoul(yytext + 2, NULL, 16);
	return INTEGER;
}
	YY_BREAK
case 224:
YY_RULE_SETUP
#line 400 "lex.l"
{
	yylval.integer = strtoul(yytext, NULL, 10);
	return INTEGER;
}
	YY_BREAK
case 225:
YY_RULE_SETUP
#line 405 "lex.l"
{
	yylval.number = strtod(yytext, NULL);
	return NUMBER;
}
	YY_BREAK
case 226:
/* rule 226 can match eol */
YY_RULE_SETUP
#line 410 "lex.l"
{ } /* eat up whitespace */
	YY_BREAK
case 227:
YY_RULE_SETUP
#line 412 "lex.l"
{
	fprintf(stderr, "%s: %d: %s at \"%s\"\n",
		input_filename, yylineno, "unexpected token", lex_text());
  }
	YY_BREAK
case 228:
YY_RULE_SETUP
#line 416 "lex.l"
ECHO;
	YY_BREAK
#line 2663 "lex.c"
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(BLOCK_COMMENT):
case YY_STATE_EOF(CHANNEL):
case YY_STATE_EOF(LINENUMBER):
case YY_STATE_EOF(FILENAME):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 659 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 659 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 658);

	return yy_is_jam ? 0 : yy_current_state;
}

    static void yyunput (int c, register char * yy_bp )
{
	register char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up yytext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = (yy_n_chars) + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

    if ( c == '\n' ){
        --yylineno;
    }

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	if ( c == '\n' )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 416 "lex.l"



char *
lex_text(void)
{
	return yytext;
  (void) yyunput;
}

#ifndef yywrap
int yywrap() { return 1; }
#endif


